/* Demonstraatioita C-kielen tyypeistä, erityisesti taulukko 
 * Käyttöjärjestelmät -- kesä 2011 / Paavo Nieminen, JYU TTL
 * <nieminen@jyu.fi>
 * 
 * Idea: - tutustu tähän koodiin lukemalla sitä ja kommentteja.
 *       - koeta ymmärtää mistä on kyse.
 *       - kokeile vapaasti, miten asiat toimivat, eli muunna, 
 *         käännä, aja
 *       - tee tehtävät; sen pitäisi onnistua, jos tämän demon 
 *         opetustavoite toteutuu
 *       - jos materiaali on epäselvä jostain kohtaa, kerro heti,
 *         niin koetan selkeyttää sitä.
 *
 * Tehtävät: 
 *  
 * - lisää aliohjelma, jolla voidaan laskea kahden eri taulukon kaikki
 *   alkiot yhteen vastinpareittain siten, että tulos jää talteen
 *   toiseen parametrina annetuista taulukoista. Esim. jos taulukko A
 *   on {1,2,3} ja taulukko B on {4,5,16} niin tulos olisi {5,7,19},
 *   ja se olisi sijoitettuna A:han tai B:hen valintasi mukaan (jonka
 *   olet tietysti dokumentoinut hyvän tavan mukaisesti riittävällä
 *   tarkkuudella...)
 *
 * - lisää aliohjelma, joka laittaa taulukkoon peräkkäiset luvut
 *   alkaen parametrina annettavasta luvusta, eli esim. kolmen alkion
 *   mittaisesta taulukosta voisi tulla {5,6,7}
 *
 * - tee molemmille pieni testi pääohjelmaan
 *
 */

#include<stdio.h>

/* Tässä asetetaan C:mäiseksi vakioksi taulukolle varattava muistin määrä: */

#define TAULUN_KOKO 5

/* Nimetään C:n tarjoama tyyppi "long long int" itselle int64_t:ksi
 * vaikkapa että se olisi nopeampi kirjoittaa (tai vaihtaa muuksi
 * myöhemmin, C:ssä kun tyyppien varsinainen koko riippuu kääntäjän
 * toteutuksesta). Tyyppien nimeäminen onnistuu typedef -sanalla.
 *
 * Tässä muuten rikotaan C90-standardia, joka ei määrittele "long long
 * int" -tyyppiä eikä printf:n formaattia "%lld". Eräs opiskelija
 * ansiokkaasti huomasi tämän (käyttäen kääntäjäoptioita -Wall ja
 * -pedantic, mikä onkin aina järkevää!). Jätämme rivin kuitenkin näin
 * pedagogisista syistä (eli havaitaan typedefin käyttötapa ja nyt
 * myös tarkkaavaisuus standardien kanssa...)
 */

typedef long long int int64_t;


int64_t koktaulu_summa(int64_t taulukko[], int nelem){
  int i;
  int64_t summa = 0;
  for (i=0; i<nelem; i++){
    summa += taulukko[i];
  }
  return summa;
}


void koktaulu_tayta(int64_t taulukko[], int nelem, int64_t value){
  int i;
  for (i=0; i<nelem; i++){
    taulukko[i] = value;
  }
}

void koktaulu_tulosta(int64_t taulukko[], int nelem){
  int i;
  for (i=0; i<nelem; i++){
    printf("%lld ", taulukko[i]);
  }
  printf("\n");
}


int main(int argc, char **argv){
  /* Tehdäksesi tehtäville testin, sun täytyy tässä toteuttaa
   * tilanvaraus vähintään yhdelle uudelle taulukolle. Esimerkkiä
   * apinoimalla pitäisi onnistua.
   */
  int64_t a[TAULUN_KOKO];

  /* HUOMAA mitä tapahtuu, kun ajat ohjelmaa useita kertoja peräkkäin!
   * C:ssä tilan varaaminen muuttujille ei alusta arvoja nollaksi tai
   * yhtään miksikään. Arvo on se, joka muistiosoitteessa sattui
   * olemaan, ja siellä voi olla mitä vain. Ohjelmoijalla on täysi
   * kontrolli ja toisaalta vastuu kaikesta. Muista alustaa muuttujat
   * C:ssä tarkoituksenmukaisesti ennen käyttöä. (Javassahan luvataan,
   * että muuttuja on nolla tai viitemuuttuja 'null' aina aluksi)
   */

  printf("Summa aluksi = %lld\n", koktaulu_summa(a, TAULUN_KOKO));

  koktaulu_tayta(a, TAULUN_KOKO, 9);
  printf("Summa lopuksi = %lld\n", koktaulu_summa(a, TAULUN_KOKO));

  printf("Taulun sisältö lopuksi: ");
  koktaulu_tulosta(a, TAULUN_KOKO);

  return 0;
}
