/* Demonstraatioita C-kielen tyypeistä, erityisesti merkkijono
 * Käyttöjärjestelmät -- kesä 2011 / Paavo Nieminen, JYU TTL
 * <nieminen@jyu.fi>
 * 
 * Idea: - tutustu tähän koodiin lukemalla sitä ja kommentteja.
 *       - koeta ymmärtää mistä on kyse.
 *       - kokeile vapaasti, miten asiat toimivat, eli muunna, 
 *         käännä, aja
 *       - tee tehtävät; sen pitäisi onnistua, jos tämän demon 
 *         opetustavoite toteutuu
 *       - jos materiaali on epäselvä jostain kohtaa, kerro heti,
 *         niin koetan selkeyttää sitä.
 *
 * Tehtävä: 
 *  
 * - lisää aliohjelma, joka poistaa merkkijonosta kaikki tietyn,
 *   parametrina annettavan, merkin esiintymät jonosta. Eli jos jonosta
 *   "Aamukasteesta alkaa aurinko" poistaisi merkin 'a', siitä pitäisi
 *   tulla "Amuksteest lk urinko". Jos tuloksesta edelleen poistaisi 
 *   merkin 'e', pitäisi jäädä enää "Amukstst lk urinko". Huomioi 
 *   C-merkkijonon toiminta, mm. nollamerkki.
 *
 * - tee tälle pieni testi pääohjelmaan
 *
 *   Lisävihje 1: Tämä on hyvä testi Ohjelmointi 1 -tietotaidolle.
 *                Joko osaat tai et osaa tehdä yksinkertaisen
 *                algoritmin:) Jos et osaa, kannattaa pikapikaa hiukan
 *                opetella!
 *
 *   Lisävihje 2: Mikäli päädyt algoritmiin, jossa käytetään
 *                paikallista aputaulukkoa, muista että se sijaitsee
 *                suorituspinossa jonka koko sisältö luonnostaan
 *                häviää aliohjelman lopussa.  Koska ns. dynaamista
 *                muistinvarausta ei ole opeteltu, ainoa tapa saada
 *                tulosjono pääohjelmalle on itse asiassa
 *                ylikirjoittaa aiempi sisältö. Se on mahdollista,
 *                koska otat parametrina muistiosoitteen. Tämän
 *                vihjeen tarkoitus ei ole sanoa että paikallisen
 *                aputaulukon käyttö olisi mitenkään tarpeellista tai
 *                järkevää...
 *
 *   Lisävihje 3: Tämän pitäisi olla helppo asia tehdä, mutta
 *                käytännössä ei näytä olevan :-) jostain
 *                syystä... eli en ihmettele, jos tässä kestää vähän
 *                aikaa. Jos ei onnistu, mieti miksi ei, ja muotoile
 *                kysymykseksi!
 *
 *   Lisävihje 4: Itse en osaisi tehdä varmaan yhtään ohjelmaa
 *                piirtelemättä ensin jotain havainnolistuksia
 *                paperille.
 *
 */

#include<stdio.h>

/* Tässä asetetaan C:mäiseksi vakioksi taulukolle varattava muistin
 * määrä:
 */

#define MAX_JONON_KOKO 100

/* Laskee merkkijonon pituuden. Huomaa, että parametri on
 * muistiosoitin eli merkkijonopuskurin ensimmäisen tavun paikka
 * prosessin virtuaaliosoiteavaruudessa jossain kohtaa ...
 */
int mjono_length(const char puskuri[], int maxkoko){
  int i;
  int pituus = 0;   /*Muuttujan voi alustaa esittelyn yhteydessä*/

  /*Perusmallisesta C-merkkijonosta ei voi tietää pituutta muuten kuin
   *laskemalla ei-nollamerkit jonon alusta alkaen!
   */
  for (i=0; i<maxkoko; i++){
    if (puskuri[i] != 0) {
      pituus += 1;
    } else {
      return pituus;
    }
  }
  return -1; 
  /*Jos pudottiin tänne, puskurissa ei ollut nollamerkkiä! Koodataan
  * miinus ykkösellä se, että annettu merkkijono oli virheellinen*/
}

/* Korvataan merkkijonosta tietyn merkin esiintymät uudella.
 * Huomautus: Edellisessä aliohjelmassa ei muutettu merkkijonon
 * pituutta, ja hyvätapainen koodaaja ilmoittaa tämän laittamalla
 * osoiteparametrin alkuun määreen 'const' eli vakio. Nyt taas
 * tarkoitus on nimenomaan muuttaa merkkijonon sisältöä ja siksi tässä
 * aliohjelmaesittelyssä ei tuota const'ia ole:
 */
int mjono_korvaa_merkki(char puskuri[], int maxkoko, 
                        char korvattava, char uusi){
  int i, lkmkorvattu = 0;

  /*Koodataan -2:lla virhetilanne, jossa yritettäisiin korvata jonon
   *loppumerkki eli se nollamerkki jollakin. Sitä ei haluttaisi ...
   */
  if (korvattava=='\0') return -2; 

  for (i=0; i<maxkoko; i++){
    if (puskuri[i]==0) {return lkmkorvattu;}
    /*Jos jono loppuu OK, palautetaan korvattujen merkkien määrä.*/

    if (puskuri[i] == korvattava) {
      puskuri[i] = uusi;
      lkmkorvattu += 1;
    }
  }
  /*Jälleen, jos merkkijono ei sisällä nollamerkkiä, koodataan tämä
    virhe miinus ykkösellä:*/
  return -1;
}


int main(int argc, char **argv){
  char munjono[MAX_JONON_KOKO] = "Zippadai dippa daabiduu";

  printf("Jono aluksi (pituus %d merkkiä) = %s\n", 
	 mjono_length(munjono, MAX_JONON_KOKO), munjono);

  /* Huomaa seuraavassa miten osoitinparametri toimii: Osoitetun
   * muistin tila voi muuttua (aliohjelmalla on "sivuvaikutus"). Tällä
   * tavoin ohjelmointi tietorakenteilla ja aliohjelmilla on melkein
   * sama asia kuin olioiden käyttö. Ajattele merkkitaulua "oliona" ja
   * aliohjelmia mjono_jotakin() "metodeina" joilla käsitellään
   * mjono-"luokan" "instansseja". "Instanssin viite" annetaan
   * ensimmäisenä parametrina "oliota" käsittelevän "metodin"
   * toteutukselle:
   */
  mjono_korvaa_merkki(munjono, MAX_JONON_KOKO, 'a', 'A');
  mjono_korvaa_merkki(munjono, MAX_JONON_KOKO, 'i', 'a');
  printf("Jono sittemmin = %s\n", munjono);

  /* Paljonkaan eroa ei ole oliokieliseen ilmaukseen
   * munjono.korvaa_merkki('a','A'). Näin ajateltuna (toteutustasolla)
   * olio-ohjelmointi on erityistapaus imperatiivisesta
   * tietorakenneohjelmoinnista.  Mutta oliomallinnus
   * suunnitteluperiaatteena ja ns. "kaikkine herkkuineen"
   * (rajapinnat, perintä, polymorfismi, ...) kielityökalun kautta
   * tuettuna on tietysti laajempi ja hieman syvällisemmin eri asia.
   */
  return 0;
}
