#include<unistd.h>
#include<stdio.h>
#include<string.h>
#include<stdlib.h>

/*
 * Dynaaminen muistinvaraus on mahdollista C-kielellä; sitä varten
 * käytetään kutsua malloc() eli "memory allocation" tjsp.
 * Käyttöjärjestelmä varaa tällöin pyynnöstä muistia prosessille, ja
 * palauttaa muistiosoitteen varatun alueen ensimmäiseen tavuun.
 *
 * Osoittimista ei pidetä kirjaa automaattisesti, vaan kaikki on
 * jälleen kerran sovellusohjelmoijan vastuulla. Varattu alue pitää
 * muistaa vapauttaa kutsumalla free() jolle on annettava parametrina
 * nimenomaan sama osoite, jonka malloc() antoi varauksen yhteydessä.
 * Jos unohtaa kutsua free() tai jos hukkaa tiedon varatuista
 * muistiosoitteista, tapahtuu ns. "muistivuoto"; varattu tila jää
 * vapauttamatta ja käyttöjärjestelmän resursseja kulutetaan
 * tarpeettomasti, mahdollisesti myös aina enenevässä määrin niin
 * kauan kuin viallinen ohjelma toimii.
 *
 * Vapaaehtoinen palautustehtävä osa 1/2: Korjaa muistivuoto (selvitä,
 * kuinka muistin vapauttaminen tapahtuu ja laita tarvittava kutsu
 * oikeaan paikkaan ohjelmaa); palauta Optimaan nimellä
 * ``muistivuoto_korjattu.c``.
 */

#include "./turvavyo.c"

/* Tässä tehdään uusi merkkijono, joka on yhdistelmä kahdesta
 * aiemmasta. Merkkijonolle varataan tilaa muistista, ja muistiosoite
 * palautetaan; aliohjelman kutsuja on vastuussa tilan
 * vapauttamisesta.
 */
char* mjono_katenoi(const char jonoA[], const char jonoB[]){
  char *jonoC, *p;
  int pitA, pitB, pitC, i;

  lopeta_jos_ei_turvallinen_kone();

  pitA = strlen(jonoA);
  pitB = strlen(jonoB);
  pitC = pitA + pitB + 1;
  
  p = jonoC = (char*) malloc(pitC);

  for(i=0;i<pitA;i++){
    *p = jonoA[i];
    p++;
  }
  for(i=0;i<pitB;i++){
    *p = jonoB[i];
    p++;
  }
  *p = '\0';

  return jonoC;
}


int main(int argc, char *argv[]){
  char a[] = "Saippua";
  char b[] = "kauppias";
  char *c;
  int i, j;

  /* Tämähän nyt näyttää tutulta Javasta, jossa String-merkkijonoja voisi
   *  yhdistää luoden samalla uuden jonon: 
   */
  c = mjono_katenoi(a,b);
   
  printf("Alkuperäiset jonot: '%s' ja '%s'.\n", a, b);
  printf("Yhdistetty jono: '%s'\n", c);

  c = mjono_katenoi(b,c);
  printf("Uusi yhdistetty jono: '%s'\n", c);

  c = mjono_katenoi(c,b);
  printf("Uusi yhdistetty jono: '%s'\n", c);

  c = mjono_katenoi(c,c);
  printf("Uusi yhdistetty jono: '%s'\n", c);


  printf("Jatkanpa tästä yhdistelemistä...\n");
  
  for(j=0; j<100; j++){
    for(i=0; i<1000; i++){
      c = mjono_katenoi(c,"s");
    }
    printf("Jononi pituus on nyt %d merkkiä\n", strlen(c));
    sleep(1);
  }

  return 0;
}
